#! /bin/bash

eval $(grep '^\(TESTPROGRAMS\|SUBDIRS\)=' runtests.sh)

rc=0

: ${RUNTEST_INDENT=0}
export RUNTEST_INDENT

for p in $TESTPROGRAMS; do
    ! tty -s || printf '%*s%-20s' $RUNTEST_INDENT '' "$p"
    ./$p >/dev/null && res='OK' || { res='FAIL'; let ++rc; }
    ! tty -s || printf '\r'

    printf '%*s%-20s%s\n' $RUNTEST_INDENT '' "$p" "$res"
done

test $rc -eq 0 || \
    printf "%*s--> %u tests failed\n" $RUNTEST_INDENT '' $rc

for d in $SUBDIRS; do
    echo "--- entering directory $d ---"
    let RUNTEST_INDENT+=2
    cd $d && bash ./runtests-X.sh || let ++rc
    let RUNTEST_INDENT-=2

    cd $OLDPWD || exit 1
done

test $rc -eq 0 && exit 0 || exit 1
